<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

// declaring the templates to load from json file
$options = array(
	'Venue Rental (template)',
	'Website Designer (template)',
	'Wedding Photographer (template)',
	'Car Rental (template)',
	'T-Shirt Printing (template)',
	'Cleaning Company (template)',
	'Funeral Home Company (template)',
	'Content Writing Agency (template)',
	'Audio Editing Services (template)',
	'Social Media Management (template)',
	'Student Fees (template)',
	'Digital Print and Lamination (template)',
	'Kitchens Renovations (template)',
	'Simple Video Budget (template)',
	'Food Catering (template)',
	'Pest Control Services (template)',
	'Book Publisher Service (template)',
	'Loan Calculator (template) (available in premium version)',
);

$choices_data = array(
	'step1'              => array(
		0 => array(
			'choiceTitle' => 'Product',
			'icon'        => 'package',
			'key'         => 'product',
		),
		1 => array(
			'choiceTitle' => 'Service',
			'icon'        => 'tool',
			'key'         => 'service',
		),
		2 => array(
			'choiceTitle' => 'Both',
			'icon'        => array(
				0 => 'tool',
				1 => 'package',
			),
			'key'         => 'both',
		),
	),
	'step2'              => array(
		0 => array(
			'choiceTitle'       => 'Straight forward',
			'choiceDescription' => 'simple pricing: 1 Item costs $10 each',
			'key'               => 'straight-forward',
		),
		1 => array(
			'choiceTitle'       => 'Bulk pricing',
			'choiceDescription' => 'I give discounts to customers who buy in bulk (10 or more items)',
			'key'               => 'bulk-pricing',
		),
		2 => array(
			'choiceTitle'       => 'Need complex math',
			'choiceDescription' => '((Item 1 + Item 2) x 12) / 12 or (Length X Width X Height)',
			'key'               => 'need-complex-math',
		),
		3 => array(
			'choiceTitle'       => 'Need to apply a percentage',
			'choiceDescription' => 'I need to take a section total and add 20% to it.',
			'key'               => 'need-to-apply-a-percentage',
		),
		4 => array(
			'choiceTitle'       => 'Need to trigger a fee or discount',
			'choiceDescription' => 'under certain situations, I want to trigger a fee of 20%',
			'key'               => 'need-to-trigger-a-fee-or-discount',
		),
		5 => array(
			'choiceTitle'       => 'Other',
			'choiceDescription' => 'I need something else',
			'key'               => 'others',
		),
	),
	'step3'              => array(
		0 => array(
			'choiceTitle'       => 'Lead Generation',
			'choiceDescription' => 'Users need to enter their contact to get the final price',
			'key'               => 'lead-gen-user-enters-contact-to-see-final-price',
		),
		1 => array(
			'choiceTitle'       => 'Lead Generation',
			'choiceDescription' => 'Users can see the total price but choose to email it to themselves',
			'key'               => 'lead-gen-user-can-email-total',
		),
		2 => array(
			'choiceTitle'       => 'E-Commerce',
			'choiceDescription' => 'I want to sell my products/services with Stripe, PayPal or WooCommerce',
			'key'               => 'e-comm',
		),
		3 => array(
			'choiceTitle'       => 'Internal Tool',
			'choiceDescription' => 'I want my sales staff to use this tool to quote prospects',
			'key'               => 'internal-tool',
		),
		4 => array(
			'choiceTitle'       => 'Product Configurator',
			'choiceDescription' => 'I have products that need customizing and have add-on options',
			'key'               => 'prod-config',
		),
		5=> array(
			'choiceTitle'       => 'Other',
			'choiceDescription' => 'I need something else',
			'key'               => 'others',
		),
	),
	'step4'              => array(
		0 => array(
			'choiceTitle'       => 'Conditional Logic',
			'choiceDescription' => 'I need to only show certain items at certain times or conditions',
			'key'               => 'conditional-logic',
		),
		1 => array(
			'choiceTitle'       => 'Multi-step',
			'choiceDescription' => 'I want to make my form clean and organized with a multi-step process',
			'key'               => 'multi-step',
		),
		2 => array(
			'choiceTitle'       => 'International Customers',
			'choiceDescription' => 'I want to display the cost in the currency of my international user\'s country',
			'key'               => 'international-customers',
		),
		3 => array(
			'choiceTitle'       => 'Automation',
			'choiceDescription' => 'I want to use API and Webhooks to connect my calculator form to other tools',
			'key'               => 'automation',
		),
		4 => array(
			'choiceTitle'       => 'Competitor Comparison',
			'choiceDescription' => 'I want to compare my prices to my competitors',
			'key'               => 'competitor-comparison',
		),
		5 => array(
			'choiceTitle'       => 'Lead Management',
			'choiceDescription' => 'I want a screen to see all my leads, where they came from, and keep track of the lead status (won, lost, in-negotiation)',
			'key'               => 'lead-management',
		),
		6 => array(
			'choiceTitle'       => 'Stylish',
			'choiceDescription' => 'I want my calculator lead form to look attractive for my users to interact with it and focus on the calls-to-actions',
			'key'               => 'stylish',
		),
		7 => array(
			'choiceTitle'       => 'Coupons',
			'choiceDescription' => 'I want a coupon system to encourage prospects to buy now.',
			'key'               => 'coupons',
		),
		8 => array(
			'choiceTitle'       => 'Other',
			'choiceDescription' => 'I need something else',
			'key'               => 'others',
		),
	),
	'step5'              => array(
		0  => array(
			'choiceTitle'       => 'Stats & Conversion Tracking',
			'choiceDescription' => 'I want to track where my orders, quotes, and leads come from.',
			'key'               => 'stats-n-conversion-tracking',
		),
		1  => array(
			'choiceTitle'       => 'Minimum Total',
			'choiceDescription' => 'I need feature to encourage the purchase of a minimum total',
			'key'               => 'set-minimum-total',
		),
		2 => array(
			'choiceTitle'       => 'Upsells & Cross Sells',
			'choiceDescription' => 'I want to encourage users to select a related service or add-on',
			'key'               => 'upsells-n-cross-sales',
		),
		3 => array(
			'choiceTitle'       => 'Add Clarity, Credibility and Reduce Friction',
			'choiceDescription' => '',
			'key'               => 'add-clarity-credibility-reduce-friction',
		),
		4 => array(
			'choiceTitle'       => 'File Uploads',
			'choiceDescription' => 'I need the user to upload images, PDF or any files',
			'key'               => 'file-uploads',
		),
		5 => array(
			'choiceTitle'       => 'Date Picker',
			'choiceDescription' => 'I want my users to be able to select a date of service',
			'key'               => 'date-picker',
		),
		6 => array(
			'choiceTitle'       => 'User Inputs',
			'choiceDescription' => 'I need to ask my users some questions to understand their needs bettter',
			'key'               => 'user-inputs',
		),
		7 => array(
			'choiceTitle'       => 'Conditional Messages & Alerts',
			'choiceDescription' => 'I need to draw attention to specific information based on predefined conditions. For instance, when a user selects a particular service, an alert is triggered to provide important information.',
			'key'               => 'conditional-messages-n-alerts',
		),
		8 => array(
			'choiceTitle'       => 'Other',
			'choiceDescription' => 'I need something else',
			'key'               => 'others',
		),
	),
	'stepResult'         => array(
		0  => array(
			'choiceTitle' => 'Conditional Logic',
			'icon'        => 'git-pull-request',
			'helpLink'    => 'https://designful.freshdesk.com/a/solutions/articles/48001157409',
			'key'         => 'conditional-logic',
		),
		1  => array(
			'choiceTitle' => 'Bulk Discounts',
			'icon'        => 'hash',
			'helpLink'    => '#',
			'key'         => 'bulk-discounts',
		),
		2  => array(
			'choiceTitle' => 'PayPal',
			'icon'        => 'paypal',
			'helpLink'    => '#',
			'key'         => 'paypal',
		),
		3  => array(
			'choiceTitle' => 'Stripe',
			'icon'        => 'stripe',
			'helpLink'    => '#',
			'key'         => 'stripe',
		),
		4  => array(
			'choiceTitle' => 'Woocommerce',
			'icon'        => 'hash',
			'helpLink'    => '#',
			'key'         => 'woocommerce',
		),
		5  => array(
			'choiceTitle' => 'Total Price',
			'icon'        => 'hash',
			'helpLink'    => 'https://designful.freshdesk.com/a/solutions/articles/48001232354',
			'key'         => 'total-price',
		),
		6  => array(
			'choiceTitle' => 'Turn Off the Total Price',
			'icon'        => 'hash',
			'helpLink'    => '#',
			'key'         => 'turn-off-total-price',
		),
		7  => array(
			'choiceTitle'       => 'Email Quote Button as Primary CTA, other buttons a secondary button',
			'choiceSimpleTitle' => 'Email Quote Button as Primary CTA',
			'icon'              => 'hash',
			'helpLink'          => '#',
			'key'               => 'email-quote-primary-cta',
		),
		8  => array(
			'choiceTitle' => 'Customize outgoing email',
			'icon'        => 'hash',
			'helpLink'    => '#',
			'key'         => 'email-quote-custom-outgoing-message',
		),
		9  => array(
			'choiceTitle' => 'Zapier/Webhooks',
			'icon'        => 'hash',
			'helpLink'    => 'https://designful.freshdesk.com/a/solutions/articles/48001216553',
			'key'         => 'use-webhooks',
		),
		10 => array(
			'choiceTitle' => 'Multi Step Feature',
			'icon'        => 'hash',
			'helpLink'    => 'https://designful.freshdesk.com/a/solutions/articles/48001217530',
			'key'         => 'use-multi-step',
		),
		11 => array(
			'choiceTitle' => 'Live Currency Conversion',
			'icon'        => 'hash',
			'helpLink'    => 'https://designful.freshdesk.com/a/solutions/articles/48001143319',
			'key'         => 'use-live-currency-conversion',
		),
		12 => array(
			'choiceTitle' => 'Custom Totals',
			'icon'        => 'hash',
			'helpLink'    => 'https://designful.freshdesk.com/a/solutions/articles/48001216489',
			'key'         => 'use-custom-totals',
		),
		13 => array(
			'choiceTitle' => 'Quote Management Screen',
			'icon'        => 'hash',
			'helpLink'    => 'https://designful.freshdesk.com/a/solutions/articles/48001216303',
			'key'         => 'use-quote-management-screen',
		),
		14 => array(
			'choiceTitle' => 'Coupon Code',
			'icon'        => 'hash',
			'helpLink'    => 'https://designful.freshdesk.com/a/solutions/articles/48001168949',
			'key'         => 'use-coupon-code-btn',
		),
		15 => array(
			'choiceTitle' => 'Cost Per Unit',
			'icon'        => 'hash',
			'helpLink'    => '#',
			'key'         => 'use-cost-per-unit',
		),
		16 => array(
			'choiceTitle' => 'Custom Totals',
			'icon'        => 'hash',
			'helpLink'    => '#',
			'key'         => 'use-custom-totals',
		),
		17 => array(
			'choiceTitle' => 'Custom Event Triggers',
			'icon'        => 'hash',
			'helpLink'    => 'https://designful.freshdesk.com/a/solutions/articles/48001201874',
			'key'         => 'use-custom-event-triggers',
		),
		18 => array(
			'choiceTitle' => 'Minimum Total',
			'icon'        => 'hash',
			'helpLink'    => '#',
			'key'         => 'use-minimum-total-feature',
		),
		19 => array(
			'choiceTitle'       => 'Conditional Logic with Text Elements',
			'choiceSimpleTitle' => 'Conditional Logic',
			'icon'              => 'hash',
			'helpLink'          => '#',
			'key'               => 'use-cl-with-txt-elements',
		),
		20 => array(
			'choiceTitle' => 'Fontend Tool-Tips',
			'icon'        => 'hash',
			'helpLink'    => 'https://designful.freshdesk.com/a/solutions/articles/48001216306',
			'key'         => 'use-frontend-tooltips',
		),
		21 => array(
			'choiceTitle' => 'Price Hint',
			'icon'        => 'hash',
			'helpLink'    => '#',
			'key'         => 'use-price-hint',
		),
		22 => array(
			'choiceTitle' => 'Email Validator',
			'icon'        => 'hash',
			'helpLink'    => '#',
			'key'         => 'use-email-validator',
		),
		23 => array(
			'choiceTitle' => 'Detailed List',
			'icon'        => 'list',
			'helpLink'    => '#',
			'key'         => 'detailed-list',
		),
		24 => array(
			'choiceTitle' => 'Turn Off the Detailed List',
			'icon'        => 'list',
			'helpLink'    => '#',
			'key'         => 'turn-off-detailed-list',
		),
		25 => array(
			'choiceTitle' => 'Activate Accordion',
			'icon'        => 'list',
			'helpLink'    => '#',
			'key'         => 'activate-accordion',
		),
		26 => array(
			'choiceTitle' => 'Activate Multiple Steps',
			'icon'        => 'list',
			'helpLink'    => '#',
			'key'         => 'activate-multiple-step',
		),
	),
	'elementSuggestions' => array(
		0  => array(
			'choiceTitle' => 'Dropdown',
			'helpLink'    => '#',
			'icon'        => 'list',
			'key'         => 'dropdown-element',
		),
		1  => array(
			'choiceTitle' => 'Simple Buttons',
			'helpLink'    => '#',
			'icon'        => 'smart_button',
			'key'         => 'simple-buttons-element',
		),
		2  => array(
			'choiceTitle' => 'Checkbox',
			'helpLink'    => '#',
			'icon'        => 'check-square',
			'key'         => 'checkbox-element',
		),
		3  => array(
			'choiceTitle' => 'Comment Box',
			'helpLink'    => '#',
			'icon'        => 'message-circle',
			'key'         => 'comment-box-element',
		),
		4  => array(
			'choiceTitle' => 'Image Buttons',
			'helpLink'    => 'https://designful.freshdesk.com/a/solutions/articles/48001207056',
			'icon'        => 'image',
			'key'         => 'img-btn-element',
		),
		5  => array(
			'choiceTitle'       => 'Text/HTML Box with conditional logic enabled',
			'choiceSimpleTitle' => 'Text/HTML',
			'helpLink'          => '#',
			'icon'              => 'code',
			'key'               => 'html-box-w-cl-element',
		),
		6  => array(
			'choiceTitle' => 'Quantity Box',
			'helpLink'    => '#',
			'icon'        => 'input-box',
			'key'         => 'quantity-box-element',
		),
		7  => array(
			'choiceTitle' => 'Custom Math',
			'helpLink'    => '#',
			'icon'        => 'plus-square',
			'key'         => 'custom-math-element',
		),
		8  => array(
			'choiceTitle' => 'File Upload',
			'helpLink'    => 'https://designful.freshdesk.com/a/solutions/articles/48001166819',
			'icon'        => 'paperclip',
			'key'         => 'file-upload-element',
		),
		9  => array(
			'choiceTitle' => 'TEXT/HTML',
			'helpLink'    => '#',
			'icon'        => 'type',
			'key'         => 'text-html-element',
		),
		10 => array(
			'choiceTitle'       => 'Slider (with elements above it in the same subsection) {therefor, it will multiply the items and act a quantity modifier)',
			'choiceSimpleTitle' => 'Slider',
			'helpLink'          => 'https://designful.freshdesk.com/a/solutions/articles/48001079780',
			'icon'              => 'sliders',
			'key'               => 'slider-element',
		),
		11 => array(
			'choiceTitle'       => 'Slider with the Bulk Pricing or Sliding Scale pricing mode turned on',
			'choiceSimpleTitle' => 'Slider',
			'helpLink'          => 'https://designful.freshdesk.com/a/solutions/articles/48001079780',
			'icon'              => 'sliders',
			'key'               => 'slider-with-bulk-or-sliding-pricing-element',
		),
		12 => array(
			'choiceTitle'       => 'Custom Math w/ Conditional Logic trigger',
			'choiceSimpleTitle' => 'Custom Math',
			'helpLink'          => 'https://designful.freshdesk.com/a/solutions/articles/48001208121',
			'icon'              => 'plus-square',
			'key'               => 'custom-math-with-cl-trigger-element',
		),
		13 => array(
			'choiceTitle'       => 'Image Buttons w/ Quantity Selector enabled',
			'choiceSimpleTitle' => 'Image Buttons',
			'helpLink'          => '#',
			'icon'              => 'image',
			'key'               => 'image-btn-w-qtn-sel-element',
		),
		14 => array(
			'choiceTitle' => 'Variable Math',
			'helpLink'    => 'https://designful.freshdesk.com/a/solutions/articles/48001202286',
			'icon'        => 'paypal',
			'key'         => 'variable-math-element',
		),
		15 => array(
			'choiceTitle' => 'Date Picker',
			'helpLink'    => 'https://designful.freshdesk.com/a/solutions/articles/48001216557',
			'icon'        => 'calendar',
			'key'         => 'date-picker-element',
		),
	),
);
$icons_list   = array();
foreach ( $choices_data as $choices_collection ) {
	// $choices_data[$key]['choiceTitle'] = __( $value['choiceTitle'], 'smartcat-calculator' );
	foreach ( $choices_collection as $choice_props ) {
		if ( isset( $choice_props['icon'] ) && ! is_array( $choice_props['icon'] ) ) {
			array_push( $icons_list, $choice_props['icon'] );
		}
		if ( isset( $choice_props['icon'] ) && is_array( $choice_props['icon'] ) ) {
			foreach ( $choice_props['icon'] as $icon ) {
				array_push( $icons_list, $icon );
			}
		}
	}
}
$icons_list = array_unique( $icons_list );

array_push( $icons_list, 'arrow-left' );

$icons_rsrc = array();

foreach ( $icons_list as $icon ) {
	$icons_rsrc[ $icon ] = scc_get_kses_extended_ruleset( $this->scc_icons[ $icon ] );
}

wp_localize_script( 'scc-backend', 'pageAddCalculator', array( 'nonce' => wp_create_nonce( 'add-calculator-page' ) ) );
?>
<div id="add-new-page-wrapper" class="container-fluid my-5 mx-auto with-vh">
	<div class="row">
		<div class="col page-section" id="welcome-section">
			<div class="bg-white">
				<div class="mx-auto py-5 text-center">
					<div class="head">
						<strong class="lead fw-bold display-5">Welcome! 👋</strong>
						<p class="fw-bold">Let’s build a new calculator</p>
					</div>
					<div class="action-btn mx-auto">
						<button type="button" class="btn-lg bg-scc-secondary mb-2 text-capitalize" data-btn-action="startQuiz">
							<span class="scc-icn-wrapper text-dark">
								<?php echo scc_get_kses_extended_ruleset( $this->scc_icons['check-square'] ); ?>
							</span>
							<span class="btn-text ms-2 text-dark">Start Wizard Quiz</span>
						</button>
						<?php if ( ! defined('SCC_DEMO_SITE') ) { ?>
							<button type="button" class="btn-lg mb-2 bg-white scc-btn-primary-outlined text-capitalize" data-btn-action="showNewCalcNameInput">
								<span class="scc-icn-wrapper">
									<?php echo scc_get_kses_extended_ruleset( $this->scc_icons['edit-2'] ); ?>
								</span>
								<span class="btn-text ms-2">Start from scratch</span>
							</button>
							<button type="button" class="btn-lg bg-white scc-btn-primary-outlined text-capitalize" data-btn-action="showTemplateChoices">
								<span class="scc-icn-wrapper">
									<?php echo scc_get_kses_extended_ruleset( $this->scc_icons['new-page-template-icon'] ); ?>
								</span>
								<span class="btn-text ms-2">Start with a template</span></button>
						<?php } ?>
					</div>
				</div>
			</div>
		</div>
		<div class="col page-section d-none" id="new-calc-creator-section">
			<div class="px-4 py-3 bg-white">
				<div class="head">
					<div class="text-muted text-uppercase">Option B</div>
					<strong>Start from scratch</strong>
				</div>
				<div class="body">
					<div class="input-group my-3">
						<input type="text" class="form-control" id="new-calc-name" placeholder="Calculator name">
					</div>
					<p>Create a new calculator from scratch with your own layout and style.</p>
					<p class="text-danger d-none">Please enter a name for the calculator</p>
				</div>
				<div class="action-btn">
					<button type="button" data-relative-field="new-calc-name" class="btn scc-btn-primary">Create calculator</button>
				</div>
			</div>
		</div>
	</div>
</div>

<div id="template-loader-wrapper" class="container-fluid with-vh d-none mt-5">
	<div class="row row-cols-1 row-cols-sm-2 g-3">
		<div class="col" id="template-loader">
			<div class="bg-white">
				<div class="px-4 py-3">
					<div class="head">
						<div class="text-muted text-uppercase">Option A</div>
						<strong>Ready-to-Play template</strong>
					</div>
					<div class="body">
						<div class="input-group my-3">
							<select class="form-select scc-ts-search" id="choose-a-template">
								<?php for ( $i = 0; $i < count( $options ); $i++ ) { ?>
									<option data-preview-image="<?php echo esc_html( $options[ $i ] ) . '.png'; ?>" value=<?php echo intval( $i ); ?> <?php
									if ( $i == 15 ) {
										echo 'disabled';
									}
									?>
																																						><?php echo intval( $i ) + 1 . ' - ' . esc_html( $options[ $i ] ); ?></option>
									<?php
								}
								?>
							</select>
						</div>
						<p>Select and lead a fully customizable template to start building with the first blocks</p>
						<p class="text-danger d-none">You have to choose an option</p>
					</div>
					<div class="action-btn">
						<button type="button" class="btn scc-btn-primary" data-relative-field="choose-a-template">Create Calculator</button>
					</div>
				</div>
			</div>
		</div>
		<div class="text-center d-none" id="calc-preview-wrapper">
			<img src="<?php echo esc_url( SCC_TEMPLATE_PREVIEW_BASEURL . '/audio_editing_template.png' ); ?>" alt="">
		</div>
	</div>
</div>
<div class="modal fade" id="quizModal" aria-hidden="true" aria-labelledby="quizModalLabel" tabindex="-1">
</div>
<div class="modal fade" id="quizModal2" aria-hidden="true" aria-labelledby="quizModalLabel2" tabindex="-1">
</div>
<div class="modal fade" id="quizModal3" aria-hidden="true" aria-labelledby="quizModalLabel3" tabindex="-1">
</div>
<div class="modal fade" id="quizModal4" aria-hidden="true" aria-labelledby="quizModalLabel4" tabindex="-1">
</div>
<div class="modal fade" id="quizModal5" aria-hidden="true" aria-labelledby="quizModalLabel5" tabindex="-1">
</div>
<div class="modal fade" id="quizResult" aria-hidden="true" aria-labelledby="quizModalResult" tabindex="-1">
</div>
<style>
	.action-btn {
		display: flex;
		flex-direction: column;
		width: 50%;
	}

	.vh-80 {
		height: 80vh;
	}

	.action-btn span.scc-icn-wrapper {
		color: var(--scc-color-primary);
		float: left;
	}

	.action-btn span.btn-text {
		color: var(--scc-color-primary);
		float: left;
	}

	.modal .card .scc-icn-wrapper {
		color: var(--scc-color-primary);
	}

	label.card {
		position: relative;
		user-select: none;
	}

	a.card-help-icn:before {
		background-color: white;
		color: black;
		content: " ";
		display: block;
		border-radius: 50%;
		border: 1px solid grey;
		text-decoration: none;
		position: absolute;
		top: 0px;
		right: 0px;
		width: 18px;
		height: 18px;
		text-align: center;
		line-height: 18px;
		transition-duration: 0.4s;
		transform: scale(0);
	}

	a.card-help-icn {
		position: absolute;
		top: 0px;
		right: 0px;
		width: 18px;
		height: 18px;
	}
	.has-help-article a.card-help-icn:before {
		border: 1px solid var(--bs-gray-dark);
		font-style: normal;
		transform: scale(1);
		content: "?";
	}

	a.card-help-icn:focus {
		box-shadow: unset;
		outline: unset;
		color: initial;
	}

	input:checked + label.card {
		background-color: var(--scc-input-field-border-color);
	}

	.modal .card {
		border: 1px solid var(--scc-input-field-border-color);
	}

	.modal.fade .modal-dialog {
		max-width: 590px !important;
	}

	/**
	* font settings for modals
	 */
	.modal.fade .modal-title {
		font-size: 24px;
	}

	.choices-wrapper p {
		font-size: 12px;
	}

	.choices-wrapper p.mb-0,
	p.lead-text {
		font-size: 18px;
	}

	.choices-wrapper label.card p {
		font-size: 14px;
	}

	.two-row-btn {
		min-height: 80px;
	}

	.single-row-btn {
		min-height: 40px;
	}

	.two-row-btn .btn-content,
	.single-row-btn .btn-content {
		margin: auto 0;
	}

	#welcome-section p,
	#welcome-section button {
		font-size: 16px;
	}
	#welcome-section .action-btn button {
		height: 55px;
	}

	.btn.scc-btn-primary:hover,
	.btn.scc-btn-primary:focus {
		color: #fff;
	}

	.modal input[type=checkbox], .modal input[type=radio] {
		margin: .25em 0 0 -1.5em;
	}
	.click-tip {
		color: var(--scc-color-primary);
	}

	.modal-back-nav {
		cursor: pointer;
		float: left;
	}

	.choices-wrapper .form-check {
		padding: 15px;
		box-shadow: 0px 0px 10px #2b2b2b15;
		margin-top: 10px;
		border-radius: 5px;
	}


	@media (min-width: 1400px) {
		.container-fluid.my-5 {
			max-width: 40% !important;
		}
	}
</style>
<script type="text/json" id="svgCollection">
<?php
echo wp_json_encode(
	$icons_rsrc
);
?>
</script>
<script type="text/json" id="choices-data">
	<?php
	echo wp_json_encode( $choices_data );
	?>
</script>
<script type="text/json" id="telemetry-status">
	<?php
	$opted_in_for_telemetry = get_option( 'scc_opted_in_for_telemetry', false );
	echo wp_json_encode( array( "usageTrackingAllowed" => $opted_in_for_telemetry ) );
	?>
</script>
<script type="text/html" id="tmpl-quiz-modal-content">
	<div class="modal-dialog modal-dialog-centered modal-dialog-scrollable">
		<div class="modal-content p-3 vh-80">
			<div class="px-3 pt-3 text-center">
				<# if (data.currentStep != 1) { #>
					<span class="scc-icn-wrapper modal-back-nav" data-dismiss="modal" onclick="handleBackNavigation({{ data.currentStep == 'Result' ? 4 : data.currentStep - 1 }}, this)">{{{svgCollection['arrow-left']}}}</span>
				<# } #>
				<h5 class="modal-title">{{data.title}}</h5>
				<p class="text-muted">{{data.subtitle}}</p>
			</div>
			<div class="modal-body pt-0">
				<# if (data.modalLead.length) { #>
				<p class="fw-bold lead-text">{{data.modalLead}}</p>
				<# } #>
				<div class="choices-wrapper"></div>
			</div>
			<# if ( Boolean( data?.actionBtnTitle?.length ) ) { #>
			<div class="modal-footer d-block">
				<div class="d-grid gap-2">
					<button class="btn scc-btn-primary" data-max-steps="5" data-next-step={{ data.quizNextStep }} type="button">{{data.actionBtnTitle}}</button>
				</div>
			</div>
			<# } #>
		</div>
	</div>
</script>
<script type="text/html" id="tmpl-quiz-choices-content">
		<# data.choices.forEach( (choice, i) => {
			let currentKey = UUIDv4.generate();
			let answersStoreIndex = quizAnswersStore['step' + data.step][choice.key];
		#>
			<div class="form-check">
				<input class="form-check-input" {{ answersStoreIndex == true ? 'checked' : '' }} type="checkbox" name="{{ choice.key }}" id="key-{{ currentKey }}">
				<label class="form-check-label" for="key-{{ currentKey }}">
					<strong>{{ choice.choiceTitle }}:</strong> {{ choice.choiceDescription }}
				</label>
			</div>
			<# if (choice.key == 'others') { #>
				<div class="form-check d-none">
					<input class="form-control form-control-sm mb-2 mt-2 w-100 others-input" type="text" name="step{{data.step}}-othersInput" id="othersInput-{{currentKey}}" placeholder="Please specify" required="">
					<label class="form-check-label" for="othersInput-{{currentKey}}">Others</label>
				</div>
			<# } #>
		<# }) #>
</script>
<script type="text/html" id="tmpl-quiz-columned-choices-content">

<div class="row row-cols-2 g-0">
	<# data.choices.forEach( (choice, i) => {
		let currentKey = UUIDv4.generate();
	#>
	<div class="col">
	  <div class="form-check">
	<input class="form-check-input" {{ quizAnswersStore['step' + data.step][choice.key] == true ? 'checked' : '' }} type="checkbox" name="{{ choice.key }}" id="key-{{ currentKey }}">
	<label class="form-check-label" for="key-{{ currentKey }}">
		{{ choice.choiceTitle }}
	</label>
	</div>
	</div>
	<# }) #>
  </div>
</script>
<script type="text/html" id="tmpl-quiz-columned-card-choices-content">
<# if (data.step == 'Result') {  #>
	<p class="mb-0">Recommended <b>Features</b></p>
	<p><span class="fw-bold click-tip">Click</span> the features below to add to your cost calculator form.</p>
<# } #>
<div class="row row-cols-3 g-0">
	<# 
	if (data.step == 'Result') {
		data = filterResultPageSuggestions(data);
	}
	data.choices.forEach( (choice, i) => {
		let currentKey = UUIDv4.generate();
		let icon = typeof(choice.icon) == 'string' ? svgCollection[choice.icon] : choice.icon.map(z => svgCollection[z]).join('');
		let choiceCardClasses = [];
		if (choice.helpLink && choice.helpLink.length > 1) {
			choiceCardClasses.push('has-help-article');
		}
		let title = choice?.choiceSimpleTitle ? choice.choiceSimpleTitle : choice.choiceTitle;
	#>
	<div class="col d-flex flex-column g-1">
		<input type="checkbox" {{ quizAnswersStore['step' + data.step][choice.key] == true ? 'checked' : '' }} class="d-none" name="{{ choice.key }}" id={{currentKey}}>
		<label class="card {{ choiceCardClasses.join( ' ' ) }} two-row-btn text-center mt-0 py-0 flex-sm-grow-1" role="button" for={{currentKey}}>
			<span class="btn-content">
				<a href="{{{ choice.helpLink }}}" target="_blank" class="card-help-icn" title="click to learn more"></a>
				<span class="scc-icn-wrapper">{{{ icon }}}</span>
				<p class="mb-0 mt-2">{{ title }}</p>
			</span>
		</label>
	</div>
	<# }) #>
  </div>
  <# if (data.step == 'Result') { #>
  <div class="mt-3">
	<p class="mb-0">Recommended <b>Elements</b></p>
	<p><span class="fw-bold click-tip">Click</span> the elements below to add to your cost calculator form.</p>
	<div class="row row-cols-3 g-0">
		<# data.elementSuggestions.forEach( (choice, i) => {
			let currentKey = UUIDv4.generate();
			let choiceCardClasses = [];
			let icon = typeof(choice.icon) == 'string' ? svgCollection[choice.icon] : choice.icon.map(z => svgCollection[z]).join('');
			if (choice.helpLink) {
				choiceCardClasses.push('has-help-article');
			}
			let title = choice?.choiceSimpleTitle ? choice.choiceSimpleTitle : choice.choiceTitle;
		#>
		<div class="col d-flex flex-column g-1">
			<input type="checkbox" {{ quizAnswersStore['step' + data.step][choice.key] == true ? 'checked' : '' }} data-element-suggestion="1" class="d-none" name="{{ choice.key }}" id={{currentKey}}>
			<label class="card {{ choiceCardClasses.join( ' ' ) }} single-row-btn text-center mt-0 py-0 flex-sm-grow-1" role="button" for={{currentKey}}>
				<a href="{{{ choice.helpLink }}}" target="_blank" class="card-help-icn" title="click to learn more"></a>
				<p class="mb-0 mt-2">
					<span class="scc-icn-wrapper">{{{ icon }}}</span>
					<span>{{ title }}</span>
				</p>
			</label>
		</div>
		<# }) #>
	</div>
  </div>
  <# } #>
</script>
<script>
	let svgCollection = [];
	window.addEventListener('DOMContentLoaded', (event) => {
		// removing WordPress's forms.css file, for 
		// document.getElementById('forms-css')?.remove();
		svgCollection = JSON.parse(document.getElementById('svgCollection')?.textContent || '[]');
		// parsing query parameters
		let urlParams = new URLSearchParams(window.location.search);
		if (urlParams.has('open-wizard')) {
			document.querySelector('[data-btn-action="startQuiz"]').click();
		}
	})
	function filterResultPageSuggestions(data) {
		let chosenOptions = Object.values(quizAnswersStore)
			.map(quizStep => Object.entries(quizStep))
			.flat().filter(answerKV => answerKV[1])
			.map(pickedChoice => pickedChoice[0]);
		let suggestionsAvailable = getFeaturesAndElementsByOptions(chosenOptions);
		
		let features = data.allFeatureSuggestions.filter(feature => suggestionsAvailable.features.includes(feature.key));
		let elements = data.allElementSuggestions.filter(element => suggestionsAvailable.elements.includes(element.key));

		// preparing the result modal data after the filtering

		data.choices = features;
		data.elementSuggestions = elements;

		return data;
		// return features.filter(feature => featsAvailable.includes(feature.key));
	}
	// function filterResultPageElementSuggestion(elements) {
	// 	return elements;
	// }
	// https://dirask.com/posts/JavaScript-UUID-function-in-Vanilla-JS-1X9kgD
	const UUIDv4 = new function() {
		const generateNumber = (limit) => {
		const value = limit * Math.random();
		return value | 0;
		};
		const generateX = () => {
			const value = generateNumber(16);
			return value.toString(16);
		};
		const generateXes = (count) => {
			let result = '';
			for(let i = 0; i < count; ++i) {
				result += generateX();
			}
			return result;
		};
		const generateVariant = () => {
			const value = generateNumber(16);
			const variant = (value & 0x3) | 0x8;
			return variant.toString(16);
		};
		// UUID v4
		//
		//   varsion: M=4 
		//   variant: N
		//   pattern: xxxxxxxx-xxxx-Mxxx-Nxxx-xxxxxxxxxxxx
		//
		this.generate = function() {
			const result = generateXes(8)
				+ '-' + generateXes(4)
				+ '-' + '4' + generateXes(3)
				+ '-' + generateVariant() + generateXes(3)
				+ '-' + generateXes(12)
			return result;
		};
	};

	const getFeaturesAndElementsByOptions = (optionsChosen) => {
		let features = [];
		let elements = [];
		optionsChosen.forEach((optKey, index) => {
			let suggestionForChoice = choicesSuggestionMap.find(suggestion => suggestion.choiceKey == optKey);
			if (suggestionForChoice) {
				suggestionForChoice.feats.forEach(feature => {
					features.push(feature);
				})
				suggestionForChoice.elements.forEach(element => {
					elements.push(element);
				})
			}
		})
		return {features, elements};
	}

	const choicesData = JSON.parse(document.querySelector('#choices-data')?.textContent || '[]');
	const telemetryStatus = JSON.parse(document.querySelector('#telemetry-status')?.textContent || '[]');

	let step2results = [{
				choiceKey: 'straight-forward',
				feats: [],
				elements: ['dropdown', 'simple-buttons', 'sliders']
			},
			{
				choiceKey: 'bulk-pricing',
				feats: ['use-cost-per-unit'],
				elements: ['slider-with-bulk-or-sliding-pricing-element']
			},
			{
				choiceKey: 'need-complex-math',
				feats: [],
				elements: ['variable-math-element']
			},
			{
				choiceKey: 'need-to-trigger-a-fee-or-discount',
				feats: [''],
				elements: ['custom-math-with-cl-trigger-element']
			}];
	let step3results = [{
				choiceKey: 'lead-gen-user-enters-contact-to-see-final-price',
				feats: ['turn-off-detailed-list', 'turn-off-total-price'],
				elements: []
			},
			{
				choiceKey: 'lead-gen-user-can-email-total',
				feats: ['email-quote-primary-cta', 'email-quote-custom-outgoing-message'],
				elements: []
			},
			{
				choiceKey: 'e-comm',
				feats: ['woocommerce', 'stripe', 'paypal'],
				elements: ['image-btn-w-qtn-sel-element']
			},
			{
				choiceKey: 'internal-tool',
				feats: ['use-webhooks'],
				elements: []
			},
			{
				choiceKey: 'prod-config',
				feats: [],
				elements: ['slider-element']
			}];
	let step4results = [{
				choiceKey: 'conditional-logic',
				feats: ['conditional-logic'],
				elements: []
			},
			{
				choiceKey: 'multi-step',
				feats: ['activate-multiple-step', 'activate-accordion'],
				elements: []
			},
			{
				choiceKey: 'international-customers',
				feats: ['use-live-currency-conversion'],
				elements: []
			},
			{
				choiceKey: 'automation',
				feats: ['use-webhooks'],
				elements: []
			}];
	let choicesSuggestionMap = [...step2results, ...step3results, ...step4results];

	const quizAnswersStore = {};
	Object.keys(choicesData).forEach(step => {
		quizAnswersStore[step] = {}
		choicesData[step].forEach(stepChoices => {
			if (stepChoices.key == 'others') {
				quizAnswersStore[step][stepChoices.key] = '';
				return;
			}
			quizAnswersStore[step][stepChoices.key] = false;
		})
	});
	const previewImagesBaseUrl = "<?php echo esc_url( SCC_TEMPLATE_PREVIEW_BASEURL ); ?>";
	const modalLeads = {
		1: 'What are you selling?',
		2: 'Choose your pricing structure',
		3: 'Choose your use cases',
		4: 'Choose your unique needs',
		5: 'Choose your needs for features',
	}
	/**
	 * *Creates new calculator with name
	 * @param name_calculator
	 */
	function scc_create_new_calculator() {
		var name = jQuery("#new-calc-name").val()
		if (!name) {
			document.querySelector('#new-calc-creator .text-danger').classList.remove('d-none')
			setTimeout(() => {
				document.querySelector('#new-calc-creator .text-danger').classList.add('d-none')
			}, 5000);
			return
		}
		showLoadingChanges()

		if (name) {
			jQuery.ajax({
				url: '<?php echo admin_url(); ?>admin-ajax.php',
				data: {
					action: 'sccCalculatorOp',
					op: "add",
					calculator_name: name,
					nonce: pageAddCalculator.nonce
				},
				success: function(data) {
					console.log(data)
					var response = JSON.parse(data);
					if (response.passed == true) {
						window.location.href = window.location.pathname + "?page=Stylish_Cost_Calculator_EditItems&id_form=" + response.data + "&new"
					} else {
						showSweet(false, "An error occured, please try again")
					}
				}
			})
		}
	}
	/**
	 * *Creates calculator with template
	 */

	function loadExample(element) {
		var el = jQuery(element).val()
		if (el == "null") {
			document.querySelector('#template-loader .text-danger').classList.remove('d-none')
			setTimeout(() => {
				document.querySelector('#template-loader .text-danger').classList.add('d-none')
			}, 5000);
			return
		}
		showLoadingChanges()
		jQuery.ajax({
			url: ajaxurl,
			data: {
				action: 'sscLoadExample',
				el: el,
				nonce: pageAddCalculator.nonce
			},
			success: function(data) {
				console.log(data)
				if (data.passed == true) {
					window.location.href = window.location.pathname + "?page=Stylish_Cost_Calculator_EditItems&id_form=" + data.data
				} else {
					showSweet(false, "An error occured, please try again")
				}
			}
		})

	}

	function getChoicesByStep (stepNumber) {
		return choicesData['step' + stepNumber];
	}

	function getTemplateTypeByStep (stepNumber) {
		if (['Result', 1].includes(stepNumber)) {
			return 'quiz-columned-card-choices-content';
		}
		return 'quiz-choices-content';
	}

	function buildChoicesContent (step) {
		let templateData = { 
			step
		}
		if (step !== 'Result') {
			templateData = {
				...templateData,
				choices : getChoicesByStep(step)
			}
		}
		if (step == 'Result') {
			// templateData.choices
			templateData = {
				...templateData,
				allFeatureSuggestions : getChoicesByStep(step),
				allElementSuggestions : choicesData['elementSuggestions']
			}
		}
		return jQuery(wp.template(getTemplateTypeByStep(step))(templateData));
	}

	function showModal(modalElementSelector, modalContentData, isFirstModal = false) {
		let { currentStep } = modalContentData;
		let modalNode = jQuery( document.getElementById( modalElementSelector ) );
		let modalContent = jQuery(wp.template('quiz-modal-content')(modalContentData));
		let choicesWrapper = modalContent.find('.choices-wrapper');
		// cleaning up previous content inside the modal body, if it was used earlier
		let modalExistingContent = modalNode[0]?.children;
		if (modalExistingContent.length > 0) {
			[...modalExistingContent].forEach(fragment => {
				fragment.remove();
			});
		}
		let choicesContent = buildChoicesContent( currentStep );
		// registering tooltip for the modal contents
		choicesContent.find('[title]').each((index, element) => {
			let tooltip = new bootstrap.Tooltip(element);
		});
		choicesWrapper.append( choicesContent );
		modalNode.append( modalContent );
		if ( isFirstModal ) {
			let cardChoices = modalNode.find('.card');
			cardChoices.attr('data-next-step', 2);
			cardChoices.attr('data-max-steps', 5);
			cardChoices.on('click', handleQuizBtnClick);
		}
		let modalActionBtn = modalNode.find('.modal-footer .scc-btn-primary');
		let modalInputFields = modalNode.find('input:not([data-element-suggestion])');
		let modalInputElementSuggestions = modalNode.find('input[data-element-suggestion]');
		modalActionBtn.on('click', handleQuizBtnClick);
		modalInputFields.on('change', (evt) => {
			updateQuizAnswersStore(evt, 'step' + currentStep);
		});
		modalInputElementSuggestions.on('change', (evt) => {
			updateQuizAnswersStore(evt, 'elementSuggestions');
		});
		let quizModal = bootstrap.Modal.getOrCreateInstance(modalNode.get(0));
		quizModal.show();
	}

	function send_setup_wizard_data(srcBtn) {
		let _quizAnswersStore = Object.assign({}, quizAnswersStore);
		// renaming stepResult to featureSuggestions
		_quizAnswersStore.featureSuggestions = _quizAnswersStore.stepResult;
		delete _quizAnswersStore.stepResult;
		jQuery.ajax({
			url: ajaxurl + '?action=scc_send_wizard_quiz_data' + '&nonce=' + pageAddCalculator.nonce,
			type: 'POST',
			dataType: 'json',
			data: JSON.stringify(_quizAnswersStore),
			beforeSend: function(xhr) {
				srcBtn.disabled = true;
				srcBtn.innerHTML = 'Please wait...';
			},
			success: function(data) {
				jQuery("#new-calc-name").val('New Calculator');
				scc_create_new_calculator();
			}
		})
	}

	function handleQuizBtnClick(evt) {
		let {currentTarget: nextBtn} = evt;
		let currentStep = Number(nextBtn.getAttribute('data-next-step'));
		let finalStep = Number(nextBtn.getAttribute('data-max-steps'));
		let modalNode = nextBtn.closest('.modal');
		let modalInstance = bootstrap.Modal.getInstance(modalNode);
		let isFinalStep = currentStep == finalStep;
		if ( currentStep !== 0 ) {
			modalInstance.hide();
		}
		if ( currentStep == 0 ) {
			// alert(JSON.stringify(quizAnswersStore));
			// since the button is from the result modal, it will be build calculator button
			let buildCalculatorActionBtn = nextBtn;
			if (buildCalculatorActionBtn.getAttribute('data-create-calculator') == 'true') {
				send_setup_wizard_data(buildCalculatorActionBtn);
				return;
			}
			Swal.fire({
				title: 'Please take a screenshot of the results and save it for later use.',
				text: "After you click the 'Build Calculator' again, you will be redirected to the calculator builder.",
				icon: 'warning',
				showCancelButton: false,
				confirmButtonColor: '#3085d6',
				cancelButtonColor: '#d33',
				confirmButtonText: 'Yes, I\'ll take a screenshot!'
			}).then((result) => {
				if (result.isConfirmed) {
					buildCalculatorActionBtn.setAttribute('data-create-calculator', 'true');
				}
			})
			return;
		};
		if ( isNaN(currentStep) ) {
			// currentStep is 'Result', thus was evaluated as NaN
			currentStep = nextBtn.getAttribute('data-next-step');
			showModal( 'quizResult' , {
				title: 'Build Your Calculator',
				subtitle: ``,
				modalLead: '',
				currentStep,
				actionBtnTitle: 'Build Calculator',
				quizNextStep: 0,
				isFinalStep: true
			} );
			return;
		};
		showModal( 'quizModal'+currentStep , {
			title: 'Wizard Quiz',
			subtitle: `Step ${currentStep} of 5`,
			modalLead: modalLeads[currentStep],
			currentStep,
			actionBtnTitle: isFinalStep ? 'Finish' : 'Next',
			quizNextStep: isFinalStep ? 'Result' : currentStep + 1,
			isFinalStep
		} );
		return 0;
	}

	function handleBackNavigation(currentStep, backBtn) {
		let isFinalStep = currentStep == 5;
		let isFirstModal = currentStep == 1;
		let templateId = isFirstModal ? 'quizModal' : 'quizModal'+currentStep;

		let modalNode = backBtn.closest('.modal');
		let modalInstance = bootstrap.Modal.getInstance(modalNode);
		modalInstance.hide();
		
		showModal( templateId , {
			title: 'Wizard Quiz',
			subtitle: `Step ${currentStep} of 5`,
			modalLead: modalLeads[currentStep],
			currentStep,
			actionBtnTitle: isFinalStep ? 'Finish' : 'Next',
			quizNextStep: isFinalStep ? 'Result' : currentStep + 1,
			isFinalStep
		}, isFirstModal );
	}

	function updateQuizAnswersStore(evt, inputOriginStep) {
		let { currentTarget: inputField } = evt;
		if (inputField.name == 'others') {
			// revealing the input field to define the others
			let defineOthersInput = document.querySelector(`[name="${inputOriginStep}-othersInput"]`);
			let defineOthersInputWrapper = defineOthersInput.closest('.form-check');
			defineOthersInputWrapper.classList.toggle('d-none');
			defineOthersInputWrapper.value = '';
			// scroll to the input field
			defineOthersInput.scrollIntoView({behavior: 'smooth'});
			// adding event listener to the input field
			if (defineOthersInput.getAttribute('data-event-registered') == 'true') return;
			defineOthersInput.addEventListener('change', (evt) => {
				quizAnswersStore[inputOriginStep][inputField.name] = evt.currentTarget.value;
			});
			defineOthersInput.setAttribute('data-event-registered', 'true');
			
			return;
		}
		quizAnswersStore[inputOriginStep][inputField.name] = inputField.checked;
	}

	document.querySelector('body').classList.remove('wp-core-ui');

	const welcomePageActionBtns = document.querySelectorAll('[data-btn-action]');
	let welcomeSection = document.querySelector('#welcome-section');
	let newCalcSection = document.querySelector('#new-calc-creator-section');
	let templatePickerFragment = document.querySelector('#template-loader-wrapper');

	const chooseATemplate = document.querySelector('#choose-a-template');
	const chooseATemplateBtn = document.querySelector('[data-relative-field="choose-a-template"]');
	const newCalcName = document.querySelector('#new-calc-name');
	const newCalcNameBtn = document.querySelector('[data-relative-field="new-calc-name"]');
	const calcPreview = document.querySelector('#calc-preview-wrapper');
	const calcPreviewImage = document.querySelector('#calc-preview-wrapper img');
	const pageWrapper = document.querySelector('#add-new-page-wrapper');
	const newCalcCreateBox = document.querySelector('#new-calc-creator');
	calcPreviewImage?.addEventListener('click', evt => {
		jQuery(chooseATemplateBtn).trigger('click');
	})
	welcomePageActionBtns.forEach(btn => {
		btn.addEventListener('click', evt => {
			const actionType = btn.getAttribute('data-btn-action');
			eval(actionType + '()');
		})
	})

	function showNewCalcNameInput() {
		welcomeSection.classList.add('d-none');
		newCalcSection.classList.remove('d-none');
	}

	function showTemplateChoices() {
		welcomeSection.classList.add('d-none');
		pageWrapper.classList.add('d-none');
		templatePickerFragment.classList.remove('d-none');
	}

	function startQuiz() {
		let currentStep = 1;
		isFinalStep = false;
		if (! telemetryStatus.usageTrackingAllowed ) {
			Swal.fire({
				title: 'By using the quiz setup modal, you\'ll be able to get a list of required features/elements you need in your calculator.',
				text: 'You can help us improve the plugin and make it better for you, by allowing us to collect anonymous usage data. This data will help us understand how the plugin is used, and what features are most important to our users.',
				showCancelButton: true,
				cancelButtonText: 'Continue without Opt-in',
				confirmButtonText: 'Yes, Continue',
			}).then(response => {
				if (response.isConfirmed) {
					// user agreed to opt-in
					// setting telemetry collection status to true
					jQuery.ajax({
						url: ajaxurl,
						type: 'POST',
						data: {
							action: 'scc_set_telemetry_state',
							state: 1,
							nonce: pageAddCalculator.nonce
						},
						success: (response) => {
							telemetryStatus.usageTrackingAllowed = true;
						}
					});
				}
			});
		}
		showModal( 'quizModal' , {
			title: 'Wizard Quiz',
			subtitle: `Step ${currentStep} of 5`,
			modalLead: modalLeads[currentStep],
			currentStep,
			quizNextStep: isFinalStep ? 'Result' : currentStep + 1,
			isFinalStep
		}, true );
	}

	chooseATemplate?.addEventListener('change', evt => {
		let selectedValue = evt.target.value;
		if (selectedValue !== 'null') {
			calcPreview.classList.remove('d-none');
			pageWrapper.classList.remove('with-vh');
			calcPreview.querySelector('img').setAttribute('src', previewImagesBaseUrl + '/' + chooseATemplate.querySelector(`[value="${chooseATemplate.value}"]`).getAttribute('data-preview-image'))
			
		} else {
			pageWrapper.classList.add('with-vh');
			calcPreview.classList.add('d-none');
		}
	})

	newCalcName.addEventListener('keyup', evt => {
		let currentValue = evt.target.value;
		// if(currentValue.length > 0 ) {
		//     newCalcNameBtn.removeAttribute('disabled');
		// } else {
		//     newCalcNameBtn.setAttribute('disabled', 1);
		// }
	})

	newCalcNameBtn.addEventListener('click', evt => {
		scc_create_new_calculator();
	})

	chooseATemplateBtn?.addEventListener('click', evt => {
		loadExample(chooseATemplate);
	})

	function showSweet(respuesta, message) {
		if (respuesta) {
			Swal.fire({
				toast: true,
				title: message,
				icon: "success",
				showConfirmButton: false,
				timer: 3000,
				position: 'bottom-end',
			})
		} else {
			Swal.fire({
				toast: true,
				title: message,
				icon: "error",
				showConfirmButton: false,
				timer: 3000,
				position: 'top-end',
				background: 'white'
			})
		}
	}

	function showLoadingChanges() {
		let timerInterval
		Swal.fire({
			toast: true,
			showConfirmButton: false,
			timer: 4000,
			background: '#F8F9FF',
			customClass: {
				loader: 'custom-loader scc-smiling-loader'
			},
			loaderHtml: `<svg role="img" aria-label="Mouth and eyes come from 9:00 and rotate clockwise into position, right eye blinks, then all parts rotate and merge into 3:00" class="smiley" viewBox="0 0 128 128" width="128px" height="128px">
		<defs>
			<clipPath id="smiley-eyes">
				<circle class="smiley__eye1" cx="64" cy="64" r="8" transform="rotate(-40,64,64) translate(0,-56)" />
				<circle class="smiley__eye2" cx="64" cy="64" r="8" transform="rotate(40,64,64) translate(0,-56)" />
			</clipPath>
			<linearGradient id="smiley-grad" x1="0" y1="0" x2="0" y2="1">
				<stop offset="0%" stop-color="#000" />
				<stop offset="100%" stop-color="#fff" />
			</linearGradient>
			<mask id="smiley-mask">
				<rect x="0" y="0" width="128" height="128" fill="url(#smiley-grad)" />
			</mask>
		</defs>
		<g stroke-linecap="round" stroke-width="12" stroke-dasharray="175.93 351.86">
			<g>
				<rect fill="hsl(193,90%,50%)" width="128" height="64" clip-path="url(#smiley-eyes)" />
				<g fill="none" stroke="hsl(193,90%,50%)">
					<circle class="smiley__mouth1" cx="64" cy="64" r="56" transform="rotate(180,64,64)" />
					<circle class="smiley__mouth2" cx="64" cy="64" r="56" transform="rotate(0,64,64)" />
				</g>
			</g>
			<g mask="url(#smiley-mask)">
				<rect fill="hsl(223,90%,50%)" width="128" height="64" clip-path="url(#smiley-eyes)" />
				<g fill="none" stroke="hsl(223,90%,50%)">
					<circle class="smiley__mouth1" cx="64" cy="64" r="56" transform="rotate(180,64,64)" />
					<circle class="smiley__mouth2" cx="64" cy="64" r="56" transform="rotate(0,64,64)" />
				</g>
			</g>
		</g>
	</svg>`,
			didOpen: (modal) => {
				// modal.querySelector('.swal2-loader').classList.remove('swal2-loader')
				Swal.showLoading()
			},
			willClose: () => {
				clearInterval(timerInterval)
			}
		})
	}
</script>
